#!/bin/bash
#
# RICOH Alto-3in1 Scanner Driver Install Script
#



################################################################################
# Initialize key variables

module="alto"	# RICOH Alto-3in1F scanner
vid="05ca"
#pid="562f"
pid_1="0454"
pid_2="0456"
code="SP 150SU/150SUw"
arch=""
sys=""

################################################################################
# 
copy_file()
{
	src=$1
	dst=$2
	
	sudo cp "$src"libsane-"$module".so.1.0.22 $dst >> /dev/null
	if [ -f "$dst""libsane-""$module"".so.1.0.22" ]; then
		#######For Redhat#######
#		sys=$(lsb_release -i 2>> /dev/null)
		if echo $sys | grep -i "redhat"  >> /dev/null
		then
			version=$(lsb_release -r 2>> /dev/null)
			if echo $version | grep -i '5.*' >> /dev/null
			then
				sudo chcon -t textrel_shlib_t "$dst""libsane-""$module"".so.1.0.22"
			fi
		fi
		########################
		echo "Copy libsane-""$module"".so.1.0.22 ... OK"
	else
		echo "Copy libsane-""$module"".so.1.0.22 ... failed"
		echo "Package installation FAILED. Please check README."
		exit 0
	fi

	sudo cp "$src""$module""_ntdcmsdll.so" $dst
	if [ -f "$src""$module""_ntdcmsdll.so" ]; then
		#######For Redhat#######
#		sys=$(lsb_release -i 2>> /dev/null)
		if echo $sys | grep -i "redhat"  >> /dev/null
		then
			version=$(lsb_release -r 2>> /dev/null)
			if echo $version | grep -i '5.*' >> /dev/null
			then
				sudo chcon -t textrel_shlib_t "$dst""$module""_ntdcmsdll.so"
			fi
		fi
		########################
		echo "Copy ""$module""_ntdcmsdll.so"" ... OK"
	else
		echo "Copy ""$module""_ntdcmsdll.so"" ... failed"
		echo "Package installation FAILED. Please check README."
		exit 0
	fi
	
	sudo rm -f "$dst"libsane-"$module".so >> /dev/null
	sudo rm -f "$dst"libsane-"$module".so.1 >> /dev/null
	
	sudo ln -s "$dst"libsane-"$module".so.1.0.22 "$dst"libsane-"$module".so >> /dev/null
	sudo ln -s "$dst"libsane-"$module".so.1.0.22 "$dst"libsane-"$module".so.1 >> /dev/null	
}

delete_file()
{
	dst=$1
	
	if [ -f "$dst""libsane-""$module"".so.1.0.22" ]; then
		sudo rm -f "$dst""libsane-""$module"".so.1.0.22"

		if [ -f "$dst""libsane-""$module"".so.1.0.22" ]; then
			echo "Remove libsane-""$module"".so.1.0.22 ... failed"
		else
			echo "Remove libsane-""$module"".so.1.0.22 ... OK"
		fi
	fi

	if [ -f "$dst""$module""_ntdcmsdll.so" ]; then
		sudo rm -f "$dst""$module""_ntdcmsdll.so"

		if [ -f "$dst""$module""_ntdcmsdll.so" ]; then
			echo "Remove ""$module""_ntdcmsdll.so"" ... failed"
		else
			echo "Remove ""$module""_ntdcmsdll.so"" ... OK"
		fi
	fi

	if [ -h "$dst"libsane-"$module".so ]; then
		sudo rm -f "$dst"libsane-"$module".so

		if [ -f "$dst"libsane-"$module".so ]; then
			echo "Remove libsane-""$module"".so ... failed"
		else
			echo "Remove libsane-""$module"".so ... OK"
		fi
	fi

	if [ -h "$dst"libsane-"$module".so.1 ]; then
		sudo rm -f "$dst"libsane-"$module".so.1

		if [ -f "$dst"libsane-"$module".so.1 ]; then
			echo "Remove libsane-""$module"".so.1 ... failed"
		else
			echo "Remove libsane-""$module"".so.1 ... OK"
		fi
	fi

	sudo rm -f /tmp/*.cal >> /dev/null
	sudo rm -f /tmp/.alto_lock >> /dev/null
	sudo rm -f ~/.sane/*.cal >> /dev/null
	sudo rm -f ~/.sane/xsane/xsane.rc >> /dev/null
	sudo rm -f /root/.sane/xsane/xsane.rc >> /dev/null
}


update_dllconf()
{
	dst=$1
	if [ -f "$dst""dll.conf" ]
	then
		if grep -i "$module" "$dst"dll.conf >> /dev/null
		then
			echo "Update dll.conf ... OK"
		else
			echo "Update dll.conf in ""$dst"" ... "
			echo "Backup it as dll.conf .bak in same directory."
			sudo cp -p "$dst"dll.conf "$dst"dll.conf.bak

			sudo sh -c "echo \"$module\" >> "$dst"dll.conf"
			echo "Update dll.conf ... OK"
		fi
	else
		if [ -f "$dst""dll.conf.bak" ]
		then
			sudo cp -p "$dst""dll.conf.bak" "$dst""dll.conf"
			if grep -i "$module" "$dst"dll.conf >> /dev/null
			then
				echo "Update dll.conf ... OK"
			else
				sudo sh -c "echo \"$module\" >> "$dst"dll.conf"
				echo "Update dll.conf ... OK"
			fi
		else
			sudo cp -p dll.conf.in $dst
			echo "Update dll.conf ... OK"
		fi

	fi
}

edit_rules()
{
	#dst=
	pid1=$pid_1
	pid2=$pid_2
	rulefile=$1
	flag="true"
	oldrulefile=""
	temp="libsane.rules"
#	sys=$(lsb_release -i 2>> /dev/null)
	
	if grep -i "{idVendor}==\""$vid"\"" "$rulefile" | grep -i "{idProduct}==\""$pid1"\""   >> /dev/null \
		&& grep -i "{idVendor}==\""$vid"\"" "$rulefile" | grep -i "{idProduct}==\""$pid2"\""   >> /dev/null
	then
		echo "Update ""$rulefile"" ... OK"
	else
		if grep -i "{idVendor}==\""$vid"\"" "$rulefile" | grep -i "{idProduct}==\""$pid1"\""   >> /dev/null \
			&& grep -i "{idVendor}==\""$vid"\"" "$rulefile" | grep -i "{idProduct}==\""$pid2"\""   >> /dev/null
		then
			echo "Update ""$rulefile"" ... OK"
		else
			if grep -i "{idVendor}==\""$vid"\"" "$rulefile" | grep -i "{idProduct}==\""$pid1"\""   >> /dev/null
			then
				pid1=""
			fi
			if grep -i "{idVendor}==\""$vid"\"" "$rulefile" | grep -i "{idProduct}==\""$pid2"\""   >> /dev/null
			then
				pid2=""
			fi

			oldrulefile="$rulefile""_bak"
			sudo mv "$rulefile" "$oldrulefile"
			if [ -f "$rulefile"".bak" ]; then
				#do nothing
				echo ""$rulefile".bak is exist!" >> /dev/null
			else
				echo "Backup "$rulefile" as "$rulefile".bak"
				sudo cp -p "$oldrulefile" "$rulefile"".bak"
			fi

			echo "Update ""$rulefile"", please waiting... "
			exec 3< "$oldrulefile"
			while read line1 0<&3
			do
				if [ "$flag" == "true" ] && echo $line1 | grep -i "4100C"  >> /dev/null
				then
					flag="false"
					read rule_line 0<&3
					new_rule="$rule_line"
					echo "" >> $temp
					if [ "$pid1" != "" ]; then
						echo "# RICOH SP 150SU Scanner" >> $temp #| sudo tee -a $rulefile >> /dev/null
						new_rule=${new_rule/03f0/"$vid"}
						new_rule=${new_rule/0101/"$pid1"}
						if echo $sys | grep -i "suse"  >> /dev/null
						then
							new_rule=${new_rule/0664/0666}
						fi
						echo "$new_rule" >> $temp
					fi
					if [ "$pid2" != "" ]; then
						new_rule="$rule_line"
						echo "# RICOH SP 150SUw Scanner" >> $temp #| sudo tee -a $rulefile >> /dev/null
						new_rule=${new_rule/03f0/"$vid"}
						new_rule=${new_rule/0101/"$pid2"}
						if echo $sys | grep -i "suse"  >> /dev/null
						then
							new_rule=${new_rule/0664/0666}
						fi
						echo "$new_rule" >> $temp
					fi
					echo "" >> $temp #| sudo tee -a $rulefile > /dev/null
					echo "$line1" >> $temp #| sudo tee -a $rulefile >> /dev/null
					echo "$rule_line" >> $temp #| sudo tee -a $rulefile >> /dev/null


				else
					echo "$line1" >> $temp #| sudo tee -a $rulefile >> /dev/null
				fi
			done
			exec 3<&-

			sudo rm "$oldrulefile"
			sudo mv "$temp" "$rulefile"
			sudo chmod 644 "$rulefile"
			sudo chown root:root "$rulefile"
			
		fi
	fi

}

update_rules()
{
	dst="/lib/udev/rules.d"
	rulefile=""

	if [ -d "$dst" ]; then
		rulefile=$(ls "$dst"/*libsane.rules 2>> /dev/null | grep libsane 2>> /dev/null)
		rulefile=${rulefile:0:34}
	fi

	if [ "$rulefile" != "" ]
	then
		edit_rules $rulefile
	fi

	dst="/etc/udev/rules.d"
	rulefile2=""
	if [ -d "$dst" ]; then
		rulefile2=$(ls "$dst"/*libsane.rules 2>> /dev/null | grep libsane 2>> /dev/null)
		rulefile2=${rulefile2:0:34}
	fi

	if [ "$rulefile2" != "" ]
	then
		edit_rules $rulefile2
	fi

	if [ "$rulefile" == "" ] && [ "$rulefile2" == "" ]
	then
		echo "Please read README for manual update."
	fi
	
}



delete_rules()
{
	dst=$1
	rulefile=""
	if [ -d "$dst" ]; then
		rulefile=$(ls "$dst"/*libsane.rules 2>> /dev/null | grep libsane 2>> /dev/null)
		rulefile=${rulefile:0:34}
	fi

	if [ "$rulefile" != "" ]
	then
		if [ -f "$rulefile"".bak" ]; then
			sudo rm -f "$rulefile"
			sudo cp -p "$rulefile"".bak" "$rulefile"
			sudo rm -f "$rulefile"".bak"
		fi
	fi

}
usb_permission()
{
	pid=$1
	devlist=$(lsusb -d "$vid":"$pid" 2>> /dev/null)
	condition=$(echo $devlist | grep -i bus 2>> /dev/null)
	while [ "$condition" != "" ]
	do
		devlist=${devlist#*Bus }
		busnum=${devlist:0:3}
		devnum=${devlist:11:3}

		devfile="/dev/bus/usb/"$busnum"/"$devnum""

		permission=$(ls -l $devfile)
		permission=${permission:7:3}

		if [ "$permission" != "rw-" ]
		then
			sudo chmod 666 $devfile
		fi
		#sudo chmod 664 /dev/bus/usb/"$busnum"/"$devnum"
		condition=$(echo $devlist | grep -i bus 2>> /dev/null)

	done
}

################################################################################
# install
install()
{
	src=""
	dst=""
	
	if [ $arch == "x86_64" ]; then
		src="./64bit/"
	else
		src="./32bit/"
	fi
	
	if [ -d "/usr/lib/sane" ]; then
		dst="/usr/lib/sane/"
		copy_file $src $dst
	fi
	
	if [ -d "/usr/local/lib/sane" ]; then
		dst="/usr/local/lib/sane/"
		copy_file $src $dst
	fi
	
	if [ -d "/usr/lib64/sane/" ]; then
		dst="/usr/lib64/sane/"
		copy_file $src $dst
	fi
	
	if [ -z "$src" ] || [ -z "$dst" ]; then
		echo "Can't install"
	fi
	
	if [ -d "/etc/sane.d" ] || [ -d "/usr/local/etc/sane.d" ]
	then

		if [ -d "/etc/sane.d" ]; then
			dst="/etc/sane.d/"
			update_dllconf $dst
		fi
		
		if [ -d "/usr/local/etc/sane.d" ]; then
			dst="/usr/local/etc/sane.d/"
			update_dllconf $dst
		fi
	else
		echo "No sane.d directory in /etc and /usr/local/etc. Can't install"
		echo "Please confirm whether have installed the SANE, and then install again."
		read -p "Install fail, press any key to continue" choice
		exit 0

	fi
	
	update_rules
	usb_permission "$pid_1"
	usb_permission "$pid_2"

	read -p "Install complelte, press any key to continue" choice
}

################################################################################
# uninstall
uninstall()
{
	dst=""
	
	if [ -d "/usr/lib/sane" ]; then
		dst="/usr/lib/sane/"
		delete_file $dst

	fi
	
	if [ -d "/usr/local/lib/sane" ]; then
		dst="/usr/local/lib/sane/"
		delete_file $dst

	fi
	
	if [ -d "/usr/lib64/sane/" ]; then
		dst="/usr/lib64/sane/"
		delete_file $dst

	fi

###Added for restore old dll.conf and 40-libsane.rules by Gavin 2014-11-12###
	dst="/etc/sane.d/"
	if [ -d "$dst" ]; then
		if [ -f "$dst""dll.conf" ] && [ -f "$dst""dll.conf.bak" ]; then
			sudo rm -f "$dst"dll.conf
			sudo cp -p "$dst"dll.conf.bak "$dst"dll.conf
			sudo rm -f "$dst"dll.conf.bak

		fi
	fi

	dst="/usr/local/etc/sane.d/"
	if [ -d "$dst" ]; then
		if [ -f "$dst""dll.conf" ] && [ -f "$dst""dll.conf.bak" ]; then
			sudo rm -f "$dst"dll.conf
			sudo cp -p "$dst"dll.conf.bak "$dst"dll.conf
			sudo rm -f "$dst"dll.conf.bak

		fi
	fi
	
	dst="/lib/udev/rules.d"
	if [ -d "$dst" ]; then
		delete_rules $dst
	fi

	dst="/etc/udev/rules.d"
	if [ -d "$dst" ]; then
		delete_rules $dst
	fi

	
###End###
	read -p "Uninstall complelte, press any key to continue" choice
}

################################################################################
# Installer Main Body
################################################################################
main()
{
	while :
	do
		echo
		echo
		# get input from the user
		read -p "Press [1/2/x] key to continue... " choice
		#make decision using case..in..esac
		case $choice in
			1)
				install
				exit 0
				;;
			2)
				uninstall
				exit 0
				;;
			x)
				exit 0
				;;
			*)
				echo "Error: invalid selection!"
				;;
		esac
	done
}


################################################################################
# Introduction
################################################################################
echo
echo "RICOH ""$code"" Scanner Installation"
echo
echo " M A I N -M E N U"
echo "1. Install."
echo "2. Uninstall."
echo "x. Exit."

arch=$(uname -m 2>> /dev/null)
sys=$(lsb_release -i 2>> /dev/null)

main


